//------------------------------------------------------
// module  : FunctionBIEDA.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionBIEDA.h"


//--------------------------//
//-- Matrice de Flottant ---//
//--------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------------//
//-- Matrice d'unsigned char --//
//-----------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de <unsigned char>
//----------------------------------------------------------
unsigned char* cmatrix_allocate_1d(int hsize)
 {
  unsigned char* matrix;
  matrix=new unsigned char[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de <unsigned char>
//----------------------------------------------------------
unsigned char** cmatrix_allocate_2d(int vsize,int hsize)
 {
  unsigned char** matrix;
  unsigned char*  imptr;

  matrix=new unsigned char*[vsize];
  imptr=new  unsigned char[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de <unsigned char>
//----------------------------------------------------------
unsigned char*** cmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  unsigned char*** matrix;

  matrix=new unsigned char**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=cmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de <unsigned char>
//----------------------------------------------------------
unsigned char**** cmatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  unsigned char**** matrix;

  matrix=new unsigned char***[fsize];

  for(int i=0;i<fsize;i++)
    matrix[i]=cmatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//----------------------------------------------------------
// libere la memoire de la matrice 1d de <unsigned char>
//----------------------------------------------------------
void free_cmatrix_1d(unsigned char* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de <unsigned char>
//----------------------------------------------------------
void free_cmatrix_2d(unsigned char** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de <unsigned char>
//----------------------------------------------------------
void free_cmatrix_3d(unsigned char*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//----------------------------------------------------------
// libere la memoire de la matrice 4d de <unsigned char>
//----------------------------------------------------------
void free_cmatrix_4d(unsigned char**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_cmatrix_3d(pmat[i],dsize);

 delete[] (pmat);
}

//--------------------//
//-- Matrix Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void copy_mat(float** pmatl1,float** pmatl2,int lgth,int wdth)
{

  for(int i=0;i<lgth;i++) for(int j=0;j<wdth;j++)
     { pmatl2[i][j]=pmatl1[i][j]; }
}


//----------------------------------------------------------
//  AverageMat
//----------------------------------------------------------
void AverageMat(float*** TabMatIn,float** MatOut,int lgth,int wdth,int number)
{
 int i,j,k;
  
 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatOut[i][j]=0.0;

 //Average
 for(k=0;k<number;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatOut[i][j]+=TabMatIn[k][i][j];

 //Norm
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatOut[i][j]/=(number);
}

//----------------------------------------------------------
// Recal                                                    
//----------------------------------------------------------
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}

//----------------------------------------------------------
// SetValToPos                                                 
//----------------------------------------------------------
void SetValToPos(float** mat,int lgth,int Pos,float Val)
{
 int i;

 //SetValToPos
 for(i=0;i<lgth;i++) mat[i][Pos]=Val;
}


//----------//
//-- FILE --//
//----------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
void GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n- Grave erreur a l'ouverture de %s -\n",path);
      exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;

  //fermeture du fichier
  fclose(fic);
}

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en ppm)             
//----------------------------------------------------------
void load_image_ppm(char* path,int*** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char varb,varv,varr;

  char stringTmp1[200],stringTmp2[200];
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".ppm")==NULL) strcat(path,".ppm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic); //P6
  tempc=fgets(stringTmp2,100,fic); //Comment

  for(;;)
    { if (((int)stringTmp2[0]==10)||((int)stringTmp2[0]==35))
      tempc=fgets(stringTmp2,100,fic); 

      else break; }

  temp=sscanf(tempc," %d %d",&ta1,&ta2);
  temp=fscanf(fic," %d",&ta3);

  //affichage de l'entete
  //printf("\n\n -- Entete --");
  //printf("\n ------------");
  //printf("\n %s %s %d %d \n %d",stringTmp1,stringTmp2,ta1,ta2,ta3);
  //printf("\n %s  %d %d \n %d",stringTmp1,ta1,ta2,ta3);
  //printf("\n ----------------------------------------------------------\n\n");
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<(wdth*3);j+=3)  
    { temp=fread(&varr,1,1,fic);
      temp=fread(&varv,1,1,fic);
      temp=fread(&varb,1,1,fic);
     
      img[2][i][j/3]=varr;        
      img[0][i][j/3]=varv;        
      img[1][i][j/3]=varb; }      

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,int*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n sauvegarde dans -> %s au format %s [%d][%d]",buff,".ppm",wdth,lgth);
  fflush(stdout);
  //exit(-1);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,float*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n sauvegarde dans -> %s au format %s [%d][%d]",buff,".ppm",wdth,lgth);
  fflush(stdout);
  //exit(-1);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }

//---------------------------
//---------------------------
// DEFORMATION                    
//---------------------------
//---------------------------
//---------------------------------------------------
// PolarMapping                      
//---------------------------------------------------
void PolarMapping(int*** imgIn,int*** imgOut,int lgth,int wdth,int RowDec,int ColDec,int inverse)  
{
 int i,j,k;
 int col_inf,col_sup;
 int row_inf,row_sup;
 float row,col;
 float t,u;
 float ng;

 float Dist,Angle;
 const float RADIAN=2.0*PI/360.0;

 int RowCenter=(int)((lgth/2))+RowDec;
 int ColCenter=(int)((wdth/2))+ColDec;
 double WDTH_MAX=360.0;
 double LGTH_MAX=sqrt(CARRE((lgth/2)+abs(RowDec))+CARRE((wdth/2)+abs(ColDec)));
 double ScalWdth=WDTH_MAX/(double)wdth;
 double ScalLgth=LGTH_MAX/(double)lgth;

 //Init
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) imgOut[k][i][j]=0;

 //PolarMapping
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
      if (!inverse)
	 { row=RowCenter+(i*ScalLgth)*(sin(j*ScalWdth*RADIAN));
	   col=ColCenter+(i*ScalLgth)*(cos(j*ScalWdth*RADIAN));  }

      if (inverse)
	 { Dist=sqrt(CARRE(i-RowCenter)+CARRE(j-ColCenter));
           Dist/=ScalLgth;
	   Angle=atan2((i-RowCenter),(j-ColCenter));
           if (Angle<0) Angle+=2*PI;
           Angle*=wdth/((float)(2.0*PI));        
           row=Dist;
           col=Angle; }

      if ((int)row>(lgth-1))  continue;
      if ((int)row<0)         continue;
      if ((int)col>(wdth-1))  continue;
      if ((int)col<0)         continue;

      col_inf=(int)(col);
      col_sup=(int)(col+1);
      row_inf=(int)(row);
      row_sup=(int)(row+1);

      if (col_sup>(wdth-1)) col_sup=(wdth-1);
      if (col_sup<0)        col_sup=0; 
      if (col_inf>(wdth-1)) col_inf=(wdth-1);
      if (col_inf<0)        col_inf=0;
      if (row_sup>(lgth-1)) row_sup=(lgth-1);
      if (row_sup<0)        row_sup=0; 
      if (row_inf>(lgth-1)) row_inf=(lgth-1);
      if (row_inf<0)        row_inf=0;

      //LinearInterpol
      imgOut[k][i][j]=imgIn[k][(int)row][(int)col];

      //BilinearInterpol
      t=u=0.0;
      if (col_sup-col_inf) t=(col-col_inf)/(col_sup-col_inf);
      if (row_sup-row_inf) u=(row-row_inf)/(row_sup-row_inf);
     	
      ng=(1-t)*(1-u)*imgIn[k][row_inf][col_inf];
      ng+=t*(1-u)*imgIn[k][row_inf][col_sup];
      ng+=t*u*imgIn[k][row_sup][col_sup];
      ng+=(1-t)*u*imgIn[k][row_sup][col_inf];
      if (ng>255) ng=255;
      if (ng<0)   ng=0; 
      if isnan(ng) printf("*");
      if (imgOut[k][i][j]) imgOut[k][i][j]=(int)ng; 
     }
}


//---------------------------------------------------
// LogPolarMapping                      
//---------------------------------------------------
void LogPolarMapping(int*** imgIn,int*** imgOut,int lgth,int wdth,int RowDec,int ColDec,int inverse)  
{
 int i,j,k;
 int col_inf,col_sup;
 int row_inf,row_sup;
 float row,col;
 float t,u;
 float ng;

 float Dist,Angle;
 const float RADIAN=2.0*PI/360.0;

 int RowCenter=(int)((lgth/2))+RowDec;
 int ColCenter=(int)((wdth/2))+ColDec;
 double WDTH_MAX=360.0;
 double LGTH_MAX=log(sqrt(CARRE((lgth/2)+abs(RowDec))+CARRE((wdth/2)+abs(ColDec))));
 double ScalWdth=WDTH_MAX/(double)wdth;
 double ScalLgth=LGTH_MAX/(double)lgth;

 //Init
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) imgOut[k][i][j]=0;

 //PolarMapping
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
      if (!inverse)
	{ Dist=exp(((float)i*ScalLgth));
          row=RowCenter+(Dist*sin(j*ScalWdth*RADIAN));
	  col=ColCenter+(Dist*cos(j*ScalWdth*RADIAN));  }

      if (inverse)
	 { Dist=log(sqrt(CARRE(i-RowCenter)+CARRE(j-ColCenter)));
           Dist/=ScalLgth;
	   Angle=atan2((i-RowCenter),(j-ColCenter));
           if (Angle<0) Angle+=2*PI;
           Angle*=wdth/((float)(2.0*PI));        
           row=Dist;
           col=Angle; }

      if ((int)row>(lgth-1))  continue;
      if ((int)row<0)         continue;
      if ((int)col>(wdth-1))  continue;
      if ((int)col<0)         continue;

      col_inf=(int)(col);
      col_sup=(int)(col+1);
      row_inf=(int)(row);
      row_sup=(int)(row+1);

      if (col_sup>(wdth-1)) col_sup=(wdth-1);
      if (col_sup<0)        col_sup=0; 
      if (col_inf>(wdth-1)) col_inf=(wdth-1);
      if (col_inf<0)        col_inf=0;
      if (row_sup>(lgth-1)) row_sup=(lgth-1);
      if (row_sup<0)        row_sup=0; 
      if (row_inf>(lgth-1)) row_inf=(lgth-1);
      if (row_inf<0)        row_inf=0;

      //LinearInterpol
      imgOut[k][i][j]=imgIn[k][(int)row][(int)col];

      //BilinearInterpol
      t=u=0.0;
      if (col_sup-col_inf) t=(col-col_inf)/(col_sup-col_inf);
      if (row_sup-row_inf) u=(row-row_inf)/(row_sup-row_inf);
     	
      ng=(1-t)*(1-u)*imgIn[k][row_inf][col_inf];
      ng+=t*(1-u)*imgIn[k][row_inf][col_sup];
      ng+=t*u*imgIn[k][row_sup][col_sup];
      ng+=(1-t)*u*imgIn[k][row_sup][col_inf];
      if (ng>255) ng=255;
      if (ng<0)   ng=0; 
      if isnan(ng) printf("*");
      imgOut[k][i][j]=(int)ng; 
     }
}

//---------------------------
//---------------------------
// TRAITEMENT                    
//---------------------------
//---------------------------
//------------------------------------------------------------
// Transf2DMat3DMat                    
//------------------------------------------------------------
void Transf2DMat3DMat(float** Mat,int*** Img,int lgth,int wdth)  
{
 int i,j,k;

 //Transf
 for(k=0;k<TROIS;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Img[k][i][j]=(int)Mat[i][j];
}

//------------------------------------------------------------
// Transf3DMat2DMat                    
//------------------------------------------------------------
void Transf3DMat2DMat(int*** Img,float** Mat,int lgth,int wdth)  
{
 int i,j;

 //Transf
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Mat[i][j]=Img[0][i][j];
}

//------------------------------------------------------------
// FillHoleImg                    
//------------------------------------------------------------
void FillHoleImg(int*** ImgIn,int lgth,int wdth,int Sz)  
{
 int i,j,k,l,m;
 int posr,posc;
 int cpt;
 float val;

 //AllocateMemory
 int*** ImgOut=imatrix_allocate_3d(3,lgth,wdth);

 //Init
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgOut[k][i][j]=ImgIn[k][i][j];

 //Loop
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (!ImgOut[k][i][j])
    {
     val=0.0;
     cpt=0;
     for(l=-Sz;l<=Sz;l++) for(m=-Sz;m<=Sz;m++)
        { posr=i+l;
          posc=j+m;
          if (posr>(lgth-1)) posr=(lgth-1);
          if (posr<0)        posr=0;
          if (posc>(wdth-1)) posc=(wdth-1);
          if (posc<0)        posc=0;
          if (ImgOut[k][posr][posc]) { cpt++; val+=ImgOut[k][posr][posc]; } }
     if (cpt) val/=(float)cpt;

     ImgOut[k][i][j]=(int)val;     
    }

 //Transfert 
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgIn[k][i][j]=ImgOut[k][i][j];

 //FreeMemory
 if (ImgOut) free_imatrix_3d(ImgOut,3);
}

//------------------------------------------------------------
// FindRegSpacedPts_2
// [0] RowDec
// [1] ColDec                
//------------------------------------------------------------
void FindRegSpacedPts_2(int lgth,int wdth,float PropWnd,int Number,int** TabPts,int** TabPtsInc)  
{
 int k;
 float RowCenter,ColCenter;
 float RowBeg,ColBeg;
 float RowEnd,ColEnd;
 float EcartRow,EcartCol;

 //>Init
 ColCenter=wdth/2;
 RowCenter=lgth/2;

 ColBeg=ColCenter-(PropWnd*ColCenter);
 RowBeg=RowCenter-(PropWnd*RowCenter);
 ColEnd=ColCenter+(PropWnd*ColCenter);
 RowEnd=RowCenter+(PropWnd*RowCenter);
 EcartRow=RowEnd-RowBeg;
 EcartCol=ColEnd-ColBeg;

 //>FillTabPts
 if (Number>1) { EcartRow/=(float)(Number-1); EcartCol/=(float)(Number-1); }
 else { EcartRow=0; EcartCol=0; }

 if (EcartRow)
 for(k=0;k<Number;k++)
   { TabPts[k][0]=(int)(RowBeg+(k*EcartRow));
     TabPts[k][1]=(int)(ColBeg+(k*EcartCol));
     TabPtsInc[k][0]=TabPts[k][0]-(lgth/2);
     TabPtsInc[k][1]=TabPts[k][1]-(wdth/2); }

 else { TabPts[0][0]=(int)RowCenter;
        TabPts[0][1]=(int)ColCenter;
        TabPtsInc[0][0]=0;
        TabPtsInc[0][1]=0; }
}

//------------------------------------------------------------
// FindRegSpacedPts_3 (enroulement)
// [0] RowDec
// [1] ColDec                
//------------------------------------------------------------
void FindRegSpacedPts_3(int lgth,int wdth,float PropWnd,int Number,int** TabPts,int** TabPtsInc)  
{
 int k;
 float RowCenter,ColCenter;
 float EcartRow,EcartCol;
 float Ecart,DeltaEcart;
 float alpha;

 //>Init
 RowCenter=(float)lgth/2.0;
 ColCenter=(float)wdth/2.0;
 EcartRow=((float)lgth/2.0)*PropWnd;
 EcartCol=((float)wdth/2.0)*PropWnd;
 Ecart=1.0;
 DeltaEcart=1.0/(1.0+(int)((Number-1.0)/4.0));
 TabPts[0][0]=(int)RowCenter;
 TabPts[0][1]=(int)ColCenter;

 //>FillTabPts
 if (Number>1)
 for(alpha=0,k=1;k<Number;k++,alpha+=(PI/2.0))
    {
     if ((k>2)&&(!((k-1)%4)))  { alpha+=(PI/4.0); Ecart-=DeltaEcart; }
     TabPts[k][0]=(int)(RowCenter+(Ecart*EcartRow*cos(alpha)));
     TabPts[k][1]=(int)(ColCenter+(Ecart*EcartCol*sin(alpha))); 
    }

 //>Fill
 for(k=0;k<Number;k++)
    { TabPtsInc[k][0]=TabPts[k][0]-(int)RowCenter;
      TabPtsInc[k][1]=TabPts[k][1]-(int)ColCenter; }
}


//--------------------
//-- SPACE COLOR -----
//--------------------
//----------------------------------------------------------*/
// RGBToHSV 
// --------
// H=[0::360]   S=[0::1]  V=[0::255]
//                        
//----------------------------------------------------------*/
void RGBToHSV(float r,float g,float b,float* h,float* s,float* v)
{
 float maxRGB=MAX(MAX(r,g),MAX(g,b));
 float minRGB=MIN(MIN(r,g),MIN(g,b));

 (*v)=maxRGB;                                                

 if (maxRGB==0)   (*s)=0.0;
 else             (*s)= (maxRGB-minRGB)/maxRGB;                    

        
 if ((*s)==0)     (*h)=0.0;                                              
 else
    { if (r==maxRGB)       (*h)=(g-b)/(maxRGB-minRGB);    
      else if (g==maxRGB)  (*h)=2+(b-r)/(maxRGB-minRGB);
      else                 (*h)=4+(r-g)/(maxRGB-minRGB);

      (*h)*=60;           
      if ((*h)<0.0)        (*h)+=360;  }
}

//----------------------------------------------------------*/
// RGBToYIQ  
//
//  |Y|  |0.299   0.587   0.114| |R|
//  |I|= |0.596  -0.275  -0.321| |G|
//  |Q|  |0.212  -0.523   0.311| |B|
//
//  Y=[0::1]
//  I=[-0.5957161349127745527::0.5957161349127745527]
//  Q=[-0.5225910452916111684::0.5225910452916111684]
//                   
//----------------------------------------------------------*/
void RGBToYIQ(float r,float g,float b,float* y,float* i,float* q)
{
  //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  b/=255.0;

  //Conversion
 (*y)=(0.299*r)+(0.587*g) +(0.114*b);
 (*i)=(0.596*r)+(-0.275*g)+(-0.321*b);
 (*q)=(0.212*r)+(-0.523*g)+(0.311*b);

 //Result
 if (0)
    {
      (*y)*=255.0;
      (*i)=(((*i)+0.6)/1.20)*255.0;
      (*q)=(((*q)+0.6)/1.20)*255.0; 
    }
}

//----------------------------------------------------------*/
// RGBToXYZ  
//
//   [ X ]   [  0.412453  0.357580  0.180423 ] [ R ] 
//   [ Y ] = [  0.212671  0.715160  0.072169 ] [ G ]
//   [ Z ]   [  0.019334  0.119193  0.950227 ] [ B ].
//
// [X,Y,Z] = [0::255]
//                   
//----------------------------------------------------------*/
void RGBToXYZ(float r,float g,float b,float* x,float* y,float* z)
{
  //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  b/=255.0;

  //Conversion
 (*x)=(0.412453*r)+(0.357580*g)+(0.180423*b);
 (*y)=(0.212671*r)+(0.715160*g)+(0.072169*b);
 (*z)=(0.019334*r)+(0.119193*g)+(0.950227*b);

  //RGB 
 (*x)*=255.0;
 (*y)*=255.0;
 (*z)*=255.0;

  //Tests
 if ((*x)>255)  (*x)=255;
 if ((*x)<0)    (*x)=0;

 if ((*y)>255)  (*y)=255;
 if ((*y)<0)    (*y)=0;

 if ((*z)>255)  (*z)=255;
 if ((*z)<0)    (*z)=0;
}

//----------------------------------------------------------*/
//  XYZtoRGB 
//
//   [ R ]   [  3.240479 -1.537150 -0.498535 ] [ X ]
//   [ G ] = [ -0.969256  1.875992  0.041556 ] [ Y ]
//   [ B ]   [  0.055648 -0.204043  1.057311 ] [ Z ].
//
// [R,G,B] = [0::255]
//                   
//----------------------------------------------------------*/
void XYZToRGB(float x,float y,float z,float* r,float* g,float* b)
{
  //XYZ en [0-1]
  x/=255.0;
  y/=255.0;
  z/=255.0;

  //Conversion
 (*r)=(3.240479*x)+(-1.537150*y)+(-0.498535*z);
 (*g)=(-0.969256*x)+(1.875992*y)+(0.041556*z);
 (*b)=(0.055648*x)+(-0.204043*y)+(1.057311*z);

 //RGB en [0-255]
 (*r)*=255.0;
 (*g)*=255.0;
 (*b)*=255.0;

 //Tests
 if ((*r)>255)  (*r)=255;
 if ((*r)<0)    (*r)=0;

 if ((*g)>255)  (*g)=255;
 if ((*g)<0)    (*g)=0;

 if ((*b)>255)  (*b)=255;
 if ((*b)<0)    (*b)=0;
}

//----------------------------------------------------------*/
// RGBToLAB  
//
// LAB = [0::100][-85::110][0::255]
//
//
//        L* = 116 * (Y/Yn)1/3 - 16    for Y/Yn > 0.008856
//        L* = 903.3 * Y/Yn             otherwise
//
//        a* = 500 * ( f(X/Xn) - f(Y/Yn) )
//        b* = 200 * ( f(Y/Yn) - f(Z/Zn) )
//            where f(t) = t1/3      for t > 0.008856
//                      f(t) = 7.787 * t + 16/116    otherwise
//                   
//----------------------------------------------------------*/
void RGBToLAB(float r,float g,float bl,float* l,float* a,float* b)
{
 float x,y,z;
 float xn,yn,zn;

 //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  bl/=255.0;

 //Conversion RGB->XYZ
  RGBToXYZ(r,g,bl,&x,&y,&z);
  RGBToXYZ(1.0,1.0,1.0,&xn,&yn,&zn);

 //Conversion XYZ->LAB
  if ((y/yn)>0.008856)  (*l)=116.0*pow((y/yn),(1.0/3.0))-16.0;
  else                  (*l)=903.3*(y/yn);

  if ((x/xn)>0.008856)  (*a)=500.0*(pow((x/xn),(1.0/3.0)));
  else                  (*a)=7.787*(x/xn)+16.0/116.0;

  if ((y/yn)>0.008856)  (*a)-=500.0*(pow((y/yn),(1.0/3.0)));
  else                  (*a)-=7.787*(y/yn)+16.0/116.0;

  if ((y/yn)>0.008856)  (*b)=500.0*(pow((y/yn),(1.0/3.0)));
  else                  (*b)=7.787*(y/yn)+16.0/116.0;

  if ((z/zn)>0.008856)  (*b)-=500.0*(pow((z/zn),(1.0/3.0)));
  else                  (*b)-=7.787*(z/zn)+16.0/116.0;
}

//----------------------------------------------------------*/
// RGBToLUV  
//
// LUV = [0::100][-86::164][-131::116]
//  
//        L* =  116 * (Y/Yn)1/3 - 16
//        u* =  13L* * ( u' - un' )
//        v* =  13L* * ( v' - vn' )
//
//      un' = 0.2009 
//      vn' = 0.4610 
//
//        u' = 4X / (X + 15Y + 3Z) = 4x / ( -2x + 12y + 3 )
//        v' = 9Y / (X + 15Y + 3Z) = 9y / ( -2x + 12y + 3 ).
//
//       x = 27u' / ( 18u' - 48v' + 36 )
//       y = 12v' / ( 18u' - 48v' + 36 ).
//               
//----------------------------------------------------------*/
void RGBToLUV(float r,float g,float bl,float* l,float* u,float* v)
{
 float x,y,z;
 float xn,yn,zn;
 float uprime,vprime;

 //Init
 uprime=0.0;
 vprime=0.0;

 //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  bl/=255.0;

 //Conversion RGB->XYZ
  RGBToXYZ(r,g,bl,&x,&y,&z);
  RGBToXYZ(1.0,1.0,1.0,&xn,&yn,&zn);

  //Calcul uprime/vprime
  if (x+(15*y)+(3*z))
   { uprime=(4*x)/(x+(15*y)+(3*z));
     vprime=(9*y)/(x+(15*y)+(3*z)); }

 //Conversion XYZ->LUV
 (*l)=116.0*pow((y/yn),(1.0/3.0))-16.0;
 (*u)=13*(*l)*(uprime-0.2009);
 (*v)=13*(*l)*(vprime-0.4610);
}

//----------------------------------------------------------*/
// LUVToRGB  
//
//  u' = u / ( 13L*) + un
//  v' = v / ( 13L* ) + vn
//  Y = (( L* + 16 ) / 116 )3
//  X = - 9Yu' / (( u' - 4 ) v' - u'v' )
//  Z = ( 9Y - 15v'Y - v'X ) / 3v' 
//
//      un' = 0.2009 
//      vn' = 0.4610 
//                   
//----------------------------------------------------------*/
void LUVToRGB(float l,float u,float v,float* r,float* g,float* bl)
{
 float x,y,z;
 float uprime,vprime;

 //Conversion LUV->XYZ
 uprime=u/(13*l)+0.2009;
 vprime=v/(13*l)+0.4610;
 
 y=pow(((l+16)/116),3.0);
 x=-9*y*uprime/(((uprime-4)*vprime)-uprime*vprime);
 z=((9*y-15*vprime*y-vprime*x)/(3*vprime));

 //Conversion XYZ->RGB
 XYZToRGB(x,y,z,r,g,bl);

 //RGB en [0-255]
 (*r)*=255.0;
 (*g)*=255.0;
 (*bl)*=255.0;

 //Tests
 if ((*r)>255)  (*r)=255;
 if ((*r)<0)    (*r)=0;

 if ((*g)>255)  (*g)=255;
 if ((*g)<0)    (*g)=0;

 if ((*bl)>255)  (*bl)=255;
 if ((*bl)<0)    (*bl)=0;
}

//----------------------------------------------------------*/
// RGBToI1I2I3  
//
// I1=(1/3) (R+G+B)
// I2=(R-B)
// I3=(2G-R-B)/2
//                   
//----------------------------------------------------------*/
void RGBToI1I2I3(float r,float g,float bl,float* i1,float* i2,float* i3)
{

  //Conversion RGB -> I1I2I3
  (*i1)=(1.0/3.0)*(r+g+bl);
  (*i2)=(r-bl);
  (*i3)=((1.0/2.0)*(2*g-r-bl));
}

//----------------------------------------------------------*/
// RGBToH1H2H3  
//
// H1= R+G
// H2= R-G
// H3= B- (1.0/2.0)(R+G)
//                   
//----------------------------------------------------------*/
void RGBToH1H2H3(float r,float g,float bl,float* h1,float* h2,float* h3)
{

  //Conversion RGB -> H1H2H3
  (*h1)=(r+g);
  (*h2)=(r-g);
  (*h3)=(bl-(1.0/2.0)*(r+g));
}

//----------------------------------------------------------*/
// RGBToTSL
//
// rp=r-(1.0/3.0);
// gp=g-(1.0/3.0);
//
//  L=(1.0/2.0)* [MAX(r,g,b)+MIN(r,g,bl)] 
//
//  Si  (gp>0)  T=((1.0/(2*PI))*atan(rp/gp))+0.25
//  Si  (gp<0)  T=((1.0/(2*PI))*atan(rp/gp))+0.75
//  Si  (!gp)   T=0.0
//
//  S=sqrt[ (9.0/5.0) (rp^2 +gp^2) ]
//                   
//----------------------------------------------------------*/
void RGBToTSL(float r,float g,float bl,float* t,float* s,float* l)
{

 float rp,gp;
 
 //RGB en [0-1]
 r/=255.0;
 g/=255.0;
 bl/=255.0;

 //r/gprime
 rp=r-(1.0/3.0);
 gp=g-(1.0/3.0);

 //min/maxRGB
 float maxRGB=MAX(MAX(r,g),MAX(g,bl));
 float minRGB=MIN(MIN(r,g),MIN(g,bl));

 //Conversion RGB -> HSV
 (*l)=(1.0/2.0)*(maxRGB+minRGB);

 if (gp>0)  (*t)=((1.0/(2*PI))*atan(rp/gp))+0.25;
 if (gp<0)  (*t)=((1.0/(2*PI))*atan(rp/gp))+0.75;
 if (!gp)   (*t)=0.0;
 if (*t<0)  (*t)=0.0;

 (*s)=sqrt((9.0/5.0)*(CARRE(rp)+CARRE(gp)));
}

//----------------------------------------------------------*/
// RGBToYCbCr
//
//  Y=(0.2989*r)+(0.5866*g)+(0.1145*bl);
//  Cb=(bl-Y)/(2-2*0.1145);
//  Cr=(r-Y)/(2-2*0.2989);
//
//                   
//----------------------------------------------------------*/
void RGBToYCbCr(float r,float g,float bl,float* Y,float* Cb,float* Cr)
{  
 //Conversion RGB -> YCbCr
 (*Y)=(0.2989*r)+(0.5866*g)+(0.1145*bl);
 (*Cb)=(bl-(*Y))/(2-2*0.1145);
 (*Cr)=(r-(*Y))/(2-2*0.2989);
}

//----------------------------------------------------------*/
// RGBToHSL
//
//  H=ACOS[ 0.5(r-g)+(r-b)) / sqrt[ (r-g)^2=(r-b)*(g-b) ] ]
// 
//  L=(1.0/2.0)* [MAX(r,g,b)+MIN(r,g,bl)] 
//
// if (l<=0.5) S=MAX(r,g,b)-MIN(r,g,b)/(MAX(r,g,b)+MIN(r,g,b))
// if (l>0.5)  S=MAX(r,g,b)-MIN(r,g,b)/(2-(MAX(r,g,b)+MIN(r,g,b)))
//                   
//----------------------------------------------------------*/
void RGBToHSL(float r,float g,float bl,float* h,float* s,float* l)
{
 float tmp1,tmp2;

 //RGB en [0-1]
 r/=255.0;
 g/=255.0;
 bl/=255.0;

 //min/maxRGB
 float maxRGB=MAX(MAX(r,g),MAX(g,bl));
 float minRGB=MIN(MIN(r,g),MIN(g,bl));

 //Conversion RGB -> HSV
 tmp1=(0.5)*((r-g)+(r-bl));
 tmp2=sqrt((CARRE(r-g))+(r-bl)*(g-bl));
 if (tmp2) (*h)=acos(tmp1/tmp2);
 else      (*h)=0.0;
 
 (*l)=(1.0/2.0)*(maxRGB+minRGB);

 (*s)=0.0;
 
  if ((*l)<=0.5) 
  if (maxRGB+minRGB)
  (*s)=(maxRGB-minRGB)/(maxRGB+minRGB);


  if ((*l)>0.5)  
  if (2.0-(maxRGB+minRGB))
  (*s)=(maxRGB-minRGB)/(2.0-(maxRGB+minRGB));
}

//----------------------------------------------------------*/
// RGBToP1P2
//
//  P1=(1.0/sqrt(2))*(g-r)/sumRGB;
//  P2=(1.0/sqrt(6))*(2*bl-r-g)/sumRGB;
//
//                   
//----------------------------------------------------------*/
void RGBToP1P2(float r,float g,float bl,float* P1,float* P2,float* P3)
{  
 float sumRGB=(r+g+bl);

 //Init
 (*P1)=0.0;
 (*P2)=0.0; 

 //Conversion RGB -> P1P2
 if (sumRGB) (*P1)=(1.0/sqrt(2))*(g-r)/sumRGB;
 if (sumRGB) (*P2)=(1.0/sqrt(6))*(2*bl-r-g)/sumRGB;
 (*P3)=0.0;
}



//----------------------------------------------------------
//
//  image[lgth][wdth] 
// 
//  bascol::         
//  -0- RGB ->    [X,Y,Z] = [0,255]
//  -1- HSV ->    H=[0::360]  S=[0::1]   V=[0::255]
//  -2- YIQ -     Y=[0::1]    I=[-0.55::0.55]  Q=[-0.4::0.4]
//  -3- XYZ ->    [X,Y,Z] = [0,255]
//  -4- LAB -     L=[0::100]    A=[-128::143]  B=[-258::237]
//  -5- LUV -     L=[-16::100]  U=[-60::145]   V=[-130::117]  
//
//  -6- i123-     i1=[0::255]    i2=[-255::255]      i3=[-255::255]  
//  -7- h123-     h1=[0::510]    h2=[-255::255]      h3=[-255::255]
//  -8- YCbCr    Y=[0::255]     Cb=[-127.5::127.5]  Cr=[-127.5::127.5]
//  -9- TSL-      T=[0::1]       S=[0::1.265]        L=[0::1]
//  -10- HSL-      H=[0::3.142]   S=[0::1]            L=[0::1] 
//  -11- P1P2      P1=[-0.707::0.707]   P2=[-0.408::0.816]     
//
//           Recalage sur [0-255] 
//
//----------------------------------------------------------     
void ColorBase(int***  imgout,int*** imgin,int lgth,int wdth,int bascol)
{
 int i,j;
 float red,green,blue;
 float col1,col2,col3;

 //Boucle                          
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
         red=imgin[0][i][j];
         green=imgin[1][i][j];
         blue=imgin[2][i][j];

         if (bascol==0)
	    { col1=red;
              col2=green;
              col3=blue;  }

         if (bascol==1)
	    { RGBToHSV(red,green,blue,&col1,&col2,&col3);
              col1=(col1/360.0)*255.0;
              col2=col2*255.0 ;
              col3=col3; }

         if (bascol==2)
	    { RGBToYIQ(red,green,blue,&col1,&col2,&col3);
              col1=col1*255.0;
              col2=((col2+0.55)/1.10)*255.0;
              col3=((col3+0.4)/0.8)*255.0; }

         if (bascol==3)
	    { RGBToXYZ(red,green,blue,&col1,&col2,&col3);
              col1=col1;
              col2=col2;
              col3=col3; } 
          
         if (bascol==4)
	    { RGBToLAB(red,green,blue,&col1,&col2,&col3);
              col1=col1*2.55;
              col2=((col2+128)/271.0)*255.0;              
              col3=((col3+258)/495.0)*255.0; }

          if (bascol==5)
	    { RGBToLUV(red,green,blue,&col1,&col2,&col3);
	       col1=((col1+16)/250.0)*255.0;
               col2=((col2+60)/205.0)*255.0;
               col3=((col3+130)/247.0)*255.0; 
           
               if (col1<0)      col1=0.0;
               if (isnan(col2)) col2=0.0;
               if (isnan(col3)) col3=0.0; }

	  if (bascol==6)
	    { RGBToI1I2I3(red,green,blue,&col1,&col2,&col3); 
              col1=col1; 
              col2=((col2+255)/2.0);
              col3=((col3+255)/2.0);  }

          if (bascol==7)
	    { RGBToH1H2H3(red,green,blue,&col1,&col2,&col3); 
              col1=col1/2.0; 
              col2=((col2+255)/2.0); 
              col3=((col3+255)/2.0); }

          if (bascol==8)
	     { RGBToYCbCr(red,green,blue,&col1,&col2,&col3); 
               col1=col1; 
              col2=col2+127.5; 
               col3=col3+127.5; }
 
          if (bascol==9)
	    { RGBToTSL(red,green,blue,&col1,&col2,&col3); 
              col1=col1*255; 
              col2=255*col2/1.265; 
              col3=col3*255;  }

          if (bascol==10)
	    { RGBToHSL(red,green,blue,&col1,&col2,&col3); 
              col1=255*col1/3.142;  
              col2=col2*254;
              col3=col3*255; }

          if (bascol==11)
	    { RGBToP1P2(red,green,blue,&col1,&col2,&col3); 
              col1=(col1+0.707)*255.0/1.414; 
              col2=(col2+0.408)*255.0/1.224; 
              col3=0.0;   }
                

          //Debug
          if (0)
	    { if (col1>255)     printf("[1>%f]",col1);
              if (col2>255)     printf("[2>%f]",col2);
              if (col3>255)     printf("[3>%f]",col3);
              if (col1<0)       printf("[1<%f]",col1);
              if (col2<0)       printf("[2<%f]",col2);
              if (col3<0)       printf("[3<%f]",col3); }

              if (isnan(col1))  printf("[*1*]");
              if (isnan(col2))  printf("[*2*]");
              if (isnan(col3))  printf("[*3*]");
              fflush(stdout); 

          if (col1>255)  col1=255.0;
          if (col2>255)  col2=255.0;
          if (col3>255)  col3=255.0;
          if (col1<0)    col1=0.0;
          if (col2<0)    col2=0.0;
          if (col3<0)    col3=0.0;
        
	 imgout[0][i][j]=(int)col1;
         imgout[1][i][j]=(int)col2;
	 imgout[2][i][j]=(int)col3;  
    }
}

//--------------------------------------------------------------------     
void ColorBase(unsigned char***  imgout,int*** imgin,int lgth,int wdth,int bascol)
{
 int i,j;
 float red,green,blue;
 float col1,col2,col3;

 //Boucle                          
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
         red=imgin[0][i][j];
         green=imgin[1][i][j];
         blue=imgin[2][i][j];

         if (bascol==0)
	    { col1=red;
              col2=green;
              col3=blue;  }

         if (bascol==1)
	    { RGBToHSV(red,green,blue,&col1,&col2,&col3);
              col1=(col1/360.0)*255.0;
              col2=col2*255.0 ;
              col3=col3; }

         if (bascol==2)
	    { RGBToYIQ(red,green,blue,&col1,&col2,&col3);
              col1=col1*255.0;
              col2=((col2+0.55)/1.10)*255.0;
              col3=((col3+0.4)/0.8)*255.0; }

         if (bascol==3)
	    { RGBToXYZ(red,green,blue,&col1,&col2,&col3);
              col1=col1;
              col2=col2;
              col3=col3; } 
          
         if (bascol==4)
	    { RGBToLAB(red,green,blue,&col1,&col2,&col3);
              col1=col1*2.55;
              col2=((col2+128)/271.0)*255.0;              
              col3=((col3+258)/495.0)*255.0; }

          if (bascol==5)
	    { RGBToLUV(red,green,blue,&col1,&col2,&col3);
	       col1=((col1+16)/250.0)*255.0;
               col2=((col2+60)/205.0)*255.0;
               col3=((col3+130)/247.0)*255.0; 
           
               if (col1<0)      col1=0.0;
               if (isnan(col2)) col2=0.0;
               if (isnan(col3)) col3=0.0; }

	  if (bascol==6)
	    { RGBToI1I2I3(red,green,blue,&col1,&col2,&col3); 
              col1=col1; 
              col2=((col2+255)/2.0);
              col3=((col3+255)/2.0);  }

          if (bascol==7)
	    { RGBToH1H2H3(red,green,blue,&col1,&col2,&col3); 
              col1=col1/2.0; 
              col2=((col2+255)/2.0); 
              col3=((col3+255)/2.0); }

          if (bascol==8)
	     { RGBToYCbCr(red,green,blue,&col1,&col2,&col3); 
               col1=col1; 
              col2=col2+127.5; 
               col3=col3+127.5; }
 
          if (bascol==9)
	    { RGBToTSL(red,green,blue,&col1,&col2,&col3); 
              col1=col1*255; 
              col2=255*col2/1.265; 
              col3=col3*255;  }

          if (bascol==10)
	    { RGBToHSL(red,green,blue,&col1,&col2,&col3); 
              col1=255*col1/3.142;  
              col2=col2*254;
              col3=col3*255; }

          if (bascol==11)
	    { RGBToP1P2(red,green,blue,&col1,&col2,&col3); 
              col1=(col1+0.707)*255.0/1.414; 
              col2=(col2+0.408)*255.0/1.224; 
              col3=0.0;   }
                

          //Debug
          if (0)
	    { if (col1>255)     printf("[1>%f]",col1);
              if (col2>255)     printf("[2>%f]",col2);
              if (col3>255)     printf("[3>%f]",col3);
              if (col1<0)       printf("[1<%f]",col1);
              if (col2<0)       printf("[2<%f]",col2);
              if (col3<0)       printf("[3<%f]",col3); }

              if (isnan(col1))  printf("[*1*]");
              if (isnan(col2))  printf("[*2*]");
              if (isnan(col3))  printf("[*3*]");
              fflush(stdout); 

          if (col1>255)  col1=255.0;
          if (col2>255)  col2=255.0;
          if (col3>255)  col3=255.0;
          if (col1<0)    col1=0.0;
          if (col2<0)    col2=0.0;
          if (col3<0)    col3=0.0;
        
	 imgout[0][i][j]=(int)col1;
         imgout[1][i][j]=(int)col2;
	 imgout[2][i][j]=(int)col3;  
    }
}

//------------------------------------
//----GRADIENT TEXTURAL---------------
//------------------------------------
//----------------------------------------------------------
// GradTex <<MultiColorSpace>> <<optimise>> <<AvecGrdient>>
// dist=3
// div=5
// SzW=7
//----------------------------------------------------------     
void GradTexMultiColor__(int*** img,float** matgrd,int lgth,int wdth,int dist,int div,int SzW,int NBBC)
 { 
  short int i,j,k,l,m;
  short int posr,posc;
  short int rowU,colU,rowD,colD;
  short int rowL,colL,rowR,colR;
  short int NbParam,NbParamColorHisto;
  short int lab;
  float ng,grad,divis,max;

  //Constantes
  //const short int NBBC=10;
  const short int NB_GRADBINS=25;  
  const short int WDTH_GRADBINS=2;
  const short int div2=(div*div); 
  const short int SzwDiv2=SzW/2;

  //Initialization
  NbParamColorHisto=(div*div*div);
  NbParam=NbParamColorHisto+(4*NB_GRADBINS); 
  divis=(256.0/(float)div); 

  //Presentation
  printf("\n > Calcul Textural/ModGrad Gradient (Multi-Color Space)");
  printf("\n      [Dist=%d][SzW=%d][NbParam:%d]>",dist,SzW,NbParam);
  fflush(stdout);

  //Conversion Couleurs
  unsigned char**** imgV=cmatrix_allocate_4d(NBBC,TROIS,lgth,wdth);
  for(k=0;k<NBBC;k++) ColorBase(imgV[k],img,lgth,wdth,k);
  
  //Initialisatio memoire
  unsigned char***  MatHis=cmatrix_allocate_3d(NbParam,lgth,wdth);
  unsigned char**   MatxNB=cmatrix_allocate_2d(lgth,wdth);
  unsigned char**   MatxHor=cmatrix_allocate_2d(lgth,wdth);
  unsigned char**   MatxVer=cmatrix_allocate_2d(lgth,wdth);
  unsigned char**   MatxDgd=cmatrix_allocate_2d(lgth,wdth);
  unsigned char**   MatxDgg=cmatrix_allocate_2d(lgth,wdth);

  //Initialization
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matgrd[i][j]=0.0;  

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { MatxHor[i][j]=0;
       MatxVer[i][j]=0;
       MatxDgd[i][j]=0; 
       MatxDgg[i][j]=0; } 

 //=============================================================
 for(m=0;m<NBBC;m++)
    {
      printf("[%d]",m);
      fflush(stdout);
      for(k=0;k<NbParam;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatHis[k][i][j]=0; 

      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
        { ng=0.5+(0.33*(imgV[m][0][i][j]+imgV[m][1][i][j]+imgV[m][2][i][j]));
          MatxNB[i][j]=(int)ng; }

      for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) 
	 { MatxHor[i][j]=abs(MatxNB[i][j-1]-MatxNB[i][j+1]);
           MatxVer[i][j]=abs(MatxNB[i-1][j]-MatxNB[i+1][j]);
           MatxDgd[i][j]=abs(MatxNB[i-1][j-1]-MatxNB[i+1][j+1]);
           MatxDgg[i][j]=abs(MatxNB[i-1][j+1]-MatxNB[i+1][j-1]); }

    //Recup Histo ColorSpaces
    //-----------------------
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
        {
         for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
            { posr=i-(SzwDiv2)+k;
              posc=j-(SzwDiv2)+l;

              if (posr<0)           posr+=lgth;
              if (posr>(lgth-1))    posr-=lgth;  
              if (posc<0)           posc+=wdth;
              if (posc>(wdth-1))    posc-=wdth;
   
              lab=((short int)(imgV[m][0][posr][posc]/divis))*(div2);
              lab+=((short int)(imgV[m][1][posr][posc]/divis))*(div);  
              lab+=((short int)(imgV[m][2][posr][posc]/divis));
   
              MatHis[lab][i][j]++; 

              lab=MatxHor[posr][posc]/WDTH_GRADBINS;
              if (lab>=NB_GRADBINS) lab=NB_GRADBINS-1; 
              MatHis[NbParamColorHisto+lab][i][j]++; 

              lab=MatxVer[posr][posc]/WDTH_GRADBINS;
              if (lab>=NB_GRADBINS) lab=NB_GRADBINS-1;  
              MatHis[NbParamColorHisto+NB_GRADBINS+lab][i][j]++; 

              lab=MatxDgd[posr][posc]/WDTH_GRADBINS;
              if (lab>=NB_GRADBINS) lab=NB_GRADBINS-1;  
              MatHis[NbParamColorHisto+(2*NB_GRADBINS)+lab][i][j]++; 

              lab=MatxDgg[posr][posc]/WDTH_GRADBINS;
              if (lab>=NB_GRADBINS) lab=NB_GRADBINS-1;  
              MatHis[NbParamColorHisto+(3*NB_GRADBINS)+lab][i][j]++; }      
        }  
  
  //Compute GradText
  //----------------
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
     rowU=(i-dist); colU=j;
     rowD=(i+dist); colD=j;
     if (rowU<0)        rowU+=lgth;
     if (rowD>(lgth-1)) rowD-=lgth;
     rowL=i; colL=(j-dist);
     rowR=i; colR=(j+dist);
     if (colL<0)        colL+=wdth;
     if (colR>(wdth-1)) colR-=wdth;

     grad=0;
     for(l=0;l<NbParam;l++) 
       { grad+=abs(MatHis[l][rowU][colU]-MatHis[l][rowD][colD]);
         grad+=abs(MatHis[l][rowR][colR]-MatHis[l][rowL][colL]); 
         grad+=abs(MatHis[l][rowU][colL]-MatHis[l][rowD][colR]); 
         grad+=abs(MatHis[l][rowU][colR]-MatHis[l][rowD][colL]); }

     matgrd[i][j]+=grad;
    }
 
    }//====================================================
 
  //==============================
  //Normalize
  //==============================
  max=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) { if (matgrd[i][j]>max) max=matgrd[i][j]; }
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  matgrd[i][j]=((matgrd[i][j]*255.0)/max);
  //==============================

  //DEBUG
  //SaveImagePgm("","ImagePot_CG",matgrd,lgth,wdth);
  //exit(-1);

  //Liberation Memoire
  if (MatHis) free_cmatrix_3d(MatHis,NbParam);
  if (imgV)   free_cmatrix_4d(imgV,NBBC,TROIS); 
  if (MatxHor) free_cmatrix_2d(MatxHor);
  if (MatxVer) free_cmatrix_2d(MatxVer);
  if (MatxDgd) free_cmatrix_2d(MatxDgd);
  if (MatxDgg) free_cmatrix_2d(MatxDgg);
  if (MatxNB)  free_cmatrix_2d(MatxNB);
 }

//----------------------------------------------------------
//  ---------------------------------   
//  ENDING
//  ---------------------------------                   
//----------------------------------------------------------
//----------------------------------------------------------
// follow
//----------------------------------------------------------  
void follow(float** mat_s,int i,int j,float** mat_o,float** mat,int lgth,int wdth,float tau_L)
 {
   if ((i<0)||(i>=lgth))  return;
   if ((j<0)||(j>=wdth))  return;

   if (mat_s[i][j]>tau_L && mat[i][j]==0.0)
      {
       mat[i][j]=255.0;

       if ((mat_o[i][j]==0.0)&&((i-1)>1)) 
	 {                   
	   follow(mat_s,i-1,j,mat_o,mat,lgth,wdth,tau_L);
	   follow(mat_s,i+1,j,mat_o,mat,lgth,wdth,tau_L);
	 }
       
       if ((mat_o[i][j]==1.0)&&((i-1)>1)&&((j-1)>1))         
	 {
	   follow(mat_s,i-1,j-1,mat_o,mat,lgth,wdth,tau_L);  
	   follow(mat_s,i+1,j+1,mat_o,mat,lgth,wdth,tau_L);
	 }
       
       if ((mat_o[i][j]==2.0)&&((j-1)>1))                    
	 {
	   follow(mat_s,i,j-1,mat_o,mat,lgth,wdth,tau_L);  
	   follow(mat_s,i,j+1,mat_o,mat,lgth,wdth,tau_L);
	 }
       
       if ((mat_o[i][j]==3.0)&&((i-1)>1)&&((j+1)<(wdth-1)))  
	 {
	   follow(mat_s,i-1,j+1,mat_o,mat,lgth,wdth,tau_L); 
	   follow(mat_s,i+1,j-1,mat_o,mat,lgth,wdth,tau_L);
	 }       
      }
 }

//---------------------------------------------------------
// AddMatrix
//----------------------------------------------------------
void AddMatrix(float** MtLab1,float** MtLab2,float** MtLab,int lgth,int wdth,float alpha)
{
 int i,j;

 //>Add
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MtLab[i][j]=MtLab1[i][j]+(alpha*MtLab2[i][j]);
}


//----------------------------------------------------------*/
// AddGradImg
//----------------------------------------------------------*/
void AddGradImg(int*** img,float** seg,float** segout,int lgth,int wdth,float fact)
{
 int i,j,k;
 float tmp;
 float gx,gy;

  //>Memory Allocation
  float** imgNB=fmatrix_allocate_2d(lgth,wdth);
  float** matgrd=fmatrix_allocate_2d(lgth,wdth);

  //>Init
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matgrd[i][j]=0.0;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
  imgNB[i][j]=(1.0/3.0)*(img[0][i][j]+img[1][i][j]+img[2][i][j]);

  //>Gradient [3 Possibilites]
  //==========================
  //Gradient du vecteur couleur
  if (0)
     { for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
         { tmp=0.0;
           if (0)
	      { for(k=0;k<3;k++) tmp+=CARRE(img[k][i+1][j]-img[k][i-1][j]);
                for(k=0;k<3;k++) tmp+=CARRE(img[k][i][j+1]-img[k][i][j-1]);
                for(k=0;k<3;k++) tmp+=CARRE(img[k][i+1][j+1]-img[k][i-1][j-1]);
                for(k=0;k<3;k++) tmp+=CARRE(img[k][i-1][j+1]-img[k][i+1][j-1]); }

           if (1)
	      { for(k=0;k<3;k++) tmp+=fabs(img[k][i+1][j]-img[k][i-1][j]);
                for(k=0;k<3;k++) tmp+=fabs(img[k][i][j+1]-img[k][i][j-1]);
                for(k=0;k<3;k++) tmp+=fabs(img[k][i+1][j+1]-img[k][i-1][j-1]);
                for(k=0;k<3;k++) tmp+=fabs(img[k][i-1][j+1]-img[k][i+1][j-1]); }
           matgrd[i][j]=sqrt(tmp); }

       Recal(matgrd,lgth,wdth); }

  //Gradient pixels N&B
  if (0)
    { for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      matgrd[i][j]=sqrt(CARRE(imgNB[i+1][j]-imgNB[i-1][j])+CARRE(imgNB[i][j+1]-imgNB[i][j-1]));
      Recal(matgrd,lgth,wdth); }

  //Gradient Norm2 2x2 window
  if (1)
    { for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
	{ gx=(imgNB[i][j+1]+imgNB[i+1][j+1])-(imgNB[i][j]+imgNB[i+1][j]);
          gy=(imgNB[i+1][j]+imgNB[i+1][j+1])-(imgNB[i][j]+imgNB[i][j+1]);
          tmp=(gx*gx)+(gy*gy);
          tmp=sqrt(tmp/4.0);
          matgrd[i][j]=tmp; } 

      Recal(matgrd,lgth,wdth); 
    }

  
  //===========================

  //>Add
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) segout[i][j]=matgrd[i][j]+(fact*seg[i][j]);
  Recal(segout,lgth,wdth);

  //>FreeMemory
  if (imgNB)  free_fmatrix_2d(imgNB);
  if (matgrd) free_fmatrix_2d(matgrd);

}

//----------------------------------------------------------*/
// GaussianFilter
//----------------------------------------------------------*/
void GaussianFilter2(float** img,float** imgout,int lgth,int wdth)
{
 int i,j;
 float tmp;

 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) imgout[i][j]=img[i][j];

 //>Filtrage
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
    { tmp=16*img[i][j];
      tmp+=4*img[i+1][j];
      tmp+=4*img[i-1][j];
      tmp+=4*img[i][j+1];
      tmp+=4*img[i][j-1];
      tmp+=img[i+1][j+1];
      tmp+=img[i-1][j-1];
      tmp+=img[i-1][j+1];
      tmp+=img[i+1][j-1];
      tmp/=36.0;
      tmp=(int)(tmp+0.5);
      imgout[i][j]=tmp; }
}

//----------------------------------------------------------*/
// GaussianFilterN
//----------------------------------------------------------*/
void GaussianFilter2N(float** img,int lgth,int wdth,int nb)
{
 int i,j,k;

 //>Memory Allocation
 float** mat=fmatrix_allocate_2d(lgth,wdth);
 float** matout=fmatrix_allocate_2d(lgth,wdth);

 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=img[i][j];

 //>Filtrage
 for(k=0;k<nb;k++) 
   { GaussianFilter2(mat,matout,lgth,wdth);
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=matout[i][j]; }

 //>Transfert
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) img[i][j]=matout[i][j];

 //>FreeMemory
 if (mat)    free_fmatrix_2d(mat);
 if (matout) free_fmatrix_2d(matout);
}

//----------------------------------------------------------
// NonMaxLocSuppr
// --------------
//   ____x      ___0   \       |     /                                 
//  |                   \ 1    | 2  / 3                                 
//  |                                                                   
//  y 
//      >> Le long du contour (de symmetrie)
//----------------------------------------------------------    
void NonMaxLocSuppression(float** matgrd,int*** Img,float** matout,int lgth,int wdth,float ess)
{
 int i,j,c;
 float k;
 float tmp;
 float Gx,Gy,Gx1,Gy1,Gx2,Gy2,Gx3,Gy3;
 float min,est;
 
 //>Allocation memoire
 float** matgrdsuppr=fmatrix_allocate_2d(lgth,wdth);
 float** matorient=fmatrix_allocate_2d(lgth,wdth);
 float** mattmp=fmatrix_allocate_2d(lgth,wdth);
 float** matNB=fmatrix_allocate_2d(lgth,wdth);
 float*** matallorient=fmatrix_allocate_3d(5,lgth,wdth);

 //>Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { matgrdsuppr[i][j]=0.0;
      mattmp[i][j]=0.0; }

 for(c=0;c<4;c++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matallorient[c][i][j]=0.0;

 //>MatriceN&B
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matNB[i][j]=0.3333*(Img[0][i][j]+Img[1][i][j]+Img[2][i][j]);

 //>Filtrage
 GaussianFilter2N(matNB,lgth,wdth,3);

 //>Orientation
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matorient[i][j]=0.0;

   //>Essai-0-
   if (ess==0)
   for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      { Gx1=(matNB[i][j-1]-matNB[i][j+1]); 
        Gy1=(matNB[i+1][j]-matNB[i-1][j]); 
        if (Gy1) matorient[i][j]+=atan(Gx1/Gy1); 
        else     matorient[i][j]=(PI/2.0); }

   //>Essai-1-
   if (ess==1)
   for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      { Gx1=(matNB[i][j-1]-matNB[i][j+1]); 
        Gy1=(matNB[i+1][j]-matNB[i-1][j]);
        Gx2=(matNB[i-1][j-1]-matNB[i+1][j+1]); 
        Gy2=(matNB[i+1][j-1]-matNB[i-1][j+1]); 

        if (Gy1) { tmp=atan(Gx1/Gy1);  
                   if (tmp<0)  tmp+=PI; 
                   if (tmp>PI) tmp-=PI;   
                   matorient[i][j]+=tmp; } 
        else     matorient[i][j]+=(PI/2.0); 

        if (Gy2) { tmp=(PI/4.0)+atan(Gx2/Gy2);  
                   if (tmp<0)  tmp+=PI; 
                   if (tmp>PI) tmp-=PI; 
                   matorient[i][j]+=tmp; } 
        else     matorient[i][j]+=(PI/4.0)+(PI/2.0); 

        matorient[i][j]/=2.0; 
        if (matorient[i][j]>PI) matorient[i][j]-=PI; 
        if (matorient[i][j]<0)  matorient[i][j]+=PI; }

   //>Essai-2-
  if (ess==2)
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
     { Gx1=(Img[0][i][j-1]-Img[0][i][j+1]); 
       Gy1=(Img[0][i+1][j]-Img[0][i-1][j]); 
       Gx2=(Img[1][i][j-1]-Img[1][i][j+1]); 
       Gy2=(Img[1][i+1][j]-Img[1][i-1][j]);
       Gx3=(Img[2][i][j-1]-Img[2][i][j+1]); 
       Gy3=(Img[2][i+1][j]-Img[2][i-1][j]);
       
       if (Gy1) { tmp=atan(Gx1/Gy1);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);

       if (Gy2) { tmp=atan(Gx2/Gy2);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0); 

       if (Gy3) { tmp=atan(Gx3/Gy3);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);  
      
       matorient[i][j]/=3.0; 
       if (matorient[i][j]>PI) matorient[i][j]-=PI; 
       if (matorient[i][j]<0)  matorient[i][j]+=PI; }

  //>Essai-3-
   if (ess==3)
   for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      { Gx1=(matgrd[i][j-1]-matgrd[i][j+1]); 
        Gy1=(matgrd[i+1][j]-matgrd[i-1][j]); 
        if (Gy1) matorient[i][j]+=atan(Gx1/Gy1); 
        else     matorient[i][j]+=(PI/2.0); }
 
   //>Essai-4-
   if (ess==4)
   for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      { Gx=(matgrd[i][j-1]-matgrd[i][j+1]);
        Gy=(matgrd[i+1][j]-matgrd[i-1][j]);
        Gx1=(matNB[i][j-1]-matNB[i][j+1]); 
        Gy1=(matNB[i+1][j]-matNB[i-1][j]); 
     
        if (Gy)  { tmp=atan(Gx/Gy); 
                   if (tmp<0)  tmp+=PI; 
                   if (tmp>PI) tmp-=PI;
                   matorient[i][j]+=tmp; }
        else     matorient[i][j]+=(PI/2.0);  

        if (Gy1) { tmp=atan(Gx1/Gy1);
                   if (tmp<0)  tmp+=PI; 
                   if (tmp>PI) tmp-=PI;
                   matorient[i][j]+=tmp; }
        else     matorient[i][j]+=(PI/2.0);

        matorient[i][j]/=2.0; 
        if (matorient[i][j]>PI) matorient[i][j]-=PI; 
        if (matorient[i][j]<0)  matorient[i][j]+=PI; }

    //>Essai-5-
  if (ess==5)
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
     { Gx=(matgrd[i][j-1]-matgrd[i][j+1]);
       Gy=(matgrd[i+1][j]-matgrd[i-1][j]);
       Gx1=(Img[0][i][j-1]-Img[0][i][j+1]); 
       Gy1=(Img[0][i+1][j]-Img[0][i-1][j]); 
       Gx2=(Img[1][i][j-1]-Img[1][i][j+1]); 
       Gy2=(Img[1][i+1][j]-Img[1][i-1][j]);
       Gx3=(Img[2][i][j-1]-Img[2][i][j+1]); 
       Gy3=(Img[2][i+1][j]-Img[2][i-1][j]);
       
       if (Gy)  { tmp=atan(Gx/Gy); 
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI; 
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);
       
       if (Gy1) { tmp=atan(Gx1/Gy1);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);

       if (Gy2) { tmp=atan(Gx2/Gy2);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0); 

       if (Gy3) { tmp=atan(Gx3/Gy3);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);  
      
       matorient[i][j]/=4.0; 
       if (matorient[i][j]>PI) matorient[i][j]-=PI; 
       if (matorient[i][j]<0)  matorient[i][j]+=PI; }
  
 //Normalisation_[0-PI]
 for(i=0;i<lgth-1;i++) for(j=0;j<wdth-1;j++) 
     if (matorient[i][j]<0) matorient[i][j]+=PI;

  //>A 45 degre pres
  for(i=0;i<(lgth-1);i++) for(j=0;j<(wdth-1);j++)
     { min=10000000; est=0;
       for(k=0.0,c=0;k<=PI;k=k+(PI/4),c++)
         { tmp=fabs(matorient[i][j]-k);
           if (tmp<min) { min=tmp; est=c;} }

       if(est==4) est=0;
       matorient[i][j]=est;  }

 //>Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matgrdsuppr[i][j]=0.0;

 //>Suppression NonMaximumLocaux
  for(i=1;i<lgth-1;i++) for(j=1;j<wdth-1;j++)
    { matgrdsuppr[i][j]=matgrd[i][j];
      
     if (matorient[i][j]==2.0)
        { if ((matgrd[i][j]<matgrd[i][j+1])||(matgrd[i][j]<matgrd[i][j-1]))  
	  matgrdsuppr[i][j]=0.0;  } 

     if (matorient[i][j]==1.0)
        { if ((matgrd[i][j]<matgrd[i+1][j-1])||(matgrd[i][j]<matgrd[i-1][j+1]))  
	  matgrdsuppr[i][j]=0.0;  }  
    
     if (matorient[i][j]==0.0)
        { if ((matgrd[i][j]<matgrd[i+1][j])||(matgrd[i][j]<matgrd[i-1][j])) 
	  matgrdsuppr[i][j]=0.0;  } 

     if (matorient[i][j]==3.0)
        { if ((matgrd[i][j]<matgrd[i+1][j+1])||(matgrd[i][j]<matgrd[i-1][j-1])) 
	  matgrdsuppr[i][j]=0.0;  }  }

 //>Transfert
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[i][j]=matgrdsuppr[i][j];

 //>Liberation memoire 
 free_fmatrix_2d(matgrdsuppr);
 free_fmatrix_2d(matorient);
 free_fmatrix_2d(mattmp);
 free_fmatrix_2d(matNB);
 free_fmatrix_3d(matallorient,3);
}

//----------------------------------------------------------
// Interpol
//----------------------------------------------------------   
void Interpol(int x0,int y0,int x1,int y1,float** MatOrien,float Val)
{
 int dx = abs(x1-x0);
 int sx = x0<x1 ? 1 : -1;
 int dy = abs(y1-y0);
 int sy = y0<y1 ? 1 : -1; 
 int err = (dx>dy ? dx : -dy)/2;
 int e2;
 float NrjPot;
 int NbPix;
 
  //Loop
  NrjPot=0.0;
  NbPix=0;
  for(;;) { MatOrien[y0][x0]=Val;
            if (x0==x1 && y0==y1) break;
            e2 = err;
            if (e2 >-dx) { err -= dy; x0 += sx; }
            if (e2 < dy) { err += dx; y0 += sy; } }
}

//=======================================================
//=======================================================
//> RestorLastLine=======================================
//=======================================================
//=======================================================
//-------------------------------------------------------
// RestorLastLine                 
//-------------------------------------------------------
void RestorLastLine(int*** img,int*** MatRest,int lgth,int wdth)
{
 int i,j,k;
 float Mean0,Mean1,Mean2,Mean3,Mean4;

 //>Cst
 const float FACT=1.5;
 const float FACT2=2.25;

 //>MemoryAllocation  
 float**  ImgNB=fmatrix_allocate_2d(lgth,wdth);
 int***   ImgTmp=imatrix_allocate_3d(TROIS,lgth,wdth);

 //Init
 for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgTmp[k][i][j]=img[k][i][j];

 //>ImgNB
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 ImgNB[i][j]=(1.0/3.0)*(img[0][i][j]+img[1][i][j]+img[2][i][j]);

 //>LastColumn
 Mean0=Mean1=Mean2=Mean3=Mean4=0.0;
 for(k=0;k<lgth;k++)
   { Mean0+=ImgNB[k][wdth-1];
     Mean1+=ImgNB[k][wdth-2];
     Mean2+=ImgNB[k][wdth-3];
     Mean3+=ImgNB[k][wdth-4]; 
     Mean4+=ImgNB[k][wdth-5]; }

 Mean0/=(lgth);
 Mean1/=(lgth);
 Mean2/=(lgth);
 Mean3/=(lgth);
 Mean4/=(lgth);

 printf("\n [%.0f:%.0f:%.0f:%.0f:%.0f]",Mean4,Mean3,Mean2,Mean1,Mean0);
 fflush(stdout);

 if (Mean2>(FACT*Mean1))  
   { printf("<>");
     for(k=0;k<3;k++) for(i=0;i<lgth;i++) ImgTmp[k][i][wdth-2]=img[k][i][wdth-3]; }

 if (Mean1>(FACT*Mean0))  
   { printf("<>");
     for(k=0;k<3;k++) for(i=0;i<lgth;i++) ImgTmp[k][i][wdth-1]=img[k][i][wdth-3]; }

 if (Mean4>(FACT2*Mean0))  
   { printf(":::::");
     for(k=0;k<3;k++) for(i=0;i<lgth;i++) 
     for(j=1;j<5;j++) ImgTmp[k][i][wdth-j]=img[k][i][wdth-5]; }

 //>LastLine
 Mean0=Mean1=Mean2=Mean3=Mean4=0.0;
 for(k=0;k<wdth;k++)
   { Mean0+=ImgNB[lgth-1][k];
     Mean1+=ImgNB[lgth-2][k];
     Mean2+=ImgNB[lgth-3][k];
     Mean3+=ImgNB[lgth-4][k]; 
     Mean4+=ImgNB[lgth-5][k]; }

 Mean0/=(wdth);
 Mean1/=(wdth);
 Mean2/=(wdth);
 Mean3/=(wdth);
 Mean4/=(wdth);

 printf("\n [%.0f:%.0f:%.0f:%.0f:%.0f]\n",Mean4,Mean3,Mean2,Mean1,Mean0);
 fflush(stdout);

 if (Mean4>(FACT2*Mean0))  
   { printf("____");
     for(k=0;k<3;k++) for(j=0;j<wdth;j++) 
     for(i=1;i<5;i++) ImgTmp[k][lgth-i][j]=img[k][lgth-5][j]; }

 //>Transfert
 for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatRest[k][i][j]=ImgTmp[k][i][j];

 //>FreeMemory
 if (ImgNB)  free_fmatrix_2d(ImgNB);
 if (ImgTmp) free_imatrix_3d(ImgTmp,TROIS);
}

//-------------------------------------------------------
// RemoveLastLineColumn                
//-------------------------------------------------------
void RemoveLastLineColumn(float** Mat,int lgth,int wdth,int nb)
{
 int i,j;

 //Remove
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { if (i<nb)          Mat[i][j]=0.0;
      if (i>(lgth-1-nb)) Mat[i][j]=0.0;
      if (j<nb)          Mat[i][j]=0.0;
      if (j>(wdth-1-nb)) Mat[i][j]=0.0;  }
}


//=======================================================
// RemoveIsolatedPix
//=======================================================
void RemoveIsolatedPix(float** Img,int lgth,int wdth,int nb)
{
 int i,j,m,n;
 int flag,cpt;

 //Filtering
 cpt=0;
 for(i=nb;i<(lgth-nb);i++) for(j=nb;j<(wdth-nb);j++)
    {
     flag=0;
     if (Img[i][j])
        {
         for(m=-nb;m<=nb;m++) for(n=-nb;n<=nb;n++) 
	 if (m||n) if (Img[i+m][j+n]) flag=1; 

         if (!flag) { Img[i][j]=0.0; cpt++; }
        } 
    }

 //Info
 printf("[cpt=%d]",cpt);
}
