//------------------------------------------------------
// module  : FunctionrBIEDA.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
//   

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>


//------------------------------------------------
// CONSTANTES & DEFINITIONS ----------------------
//------------------------------------------------
#define PI  3.14159
#define GREY_LEVEL 255
#define TROIS 3

#define CARRE(X) ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))
#define SWAP(x,y) {float t;t=x;x=y;y=t; }


//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------

//>Matrix Allocation
float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);
int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);
int***    imatrix_allocate_3d(int,int,int);
unsigned char*      cmatrix_allocate_1d(int);
unsigned char**     cmatrix_allocate_2d(int,int);
unsigned char***    cmatrix_allocate_3d(int,int,int);
unsigned char****   cmatrix_allocate_4d(int,int,int,int);

void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);
void  free_cmatrix_1d(unsigned char*);
void  free_cmatrix_2d(unsigned char**);
void  free_cmatrix_3d(unsigned char***,int);
void  free_cmatrix_4d(unsigned char****,int,int);

//>Matrix Gestion 
void  copy_mat(float**,float**,int,int);
void  AverageMat(float***,float**,int,int,int);
void  Recal(float**,int,int);
void  SetValToPos(float**,int,int,float);

//>Load/Save File
void GetLengthWidth(char*,int*,int*);
void load_image_ppm(char*,int***,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
void SaveImagePpm(char*,char*,int***,int,int);
void SaveImagePpm(char*,char*,float***,int,int);

//>LogPolarMapping
void PolarMapping(int***,int***,int,int,int,int,int);
void LogPolarMapping(int***,int***,int,int,int,int,int);
void Transf2DMat3DMat(float**,int***,int,int);
void Transf3DMat2DMat(int***,float**,int,int);
void FillHoleImg(int***,int,int,int);
void FindRegSpacedPts_2(int,int,float,int,int**,int**);

//>Space Color
void RGBToHSV(float,float,float,float*,float*,float*);
void RGBToYIQ(float,float,float,float*,float*,float*);
void RGBToXYZ(float,float,float,float*,float*,float*);
void XYZToRGB(float,float,float,float*,float*,float*);
void RGBToLAB(float,float,float,float*,float*,float*);
void RGBToLUV(float,float,float,float*,float*,float*);
void RGBToI1I2I3(float,float,float,float*,float*,float*);
void RGBToH1H2H3(float,float,float,float*,float*,float*);
void RGBToHSL(float,float,float,float*,float*,float*);
void RGBToTSL(float,float,float,float*,float*,float*);
void RGBToYCbCr(float,float,float,float*,float*,float*);
void RGBToP1P2(float,float,float,float*,float*,float*);
void ColorBase(int***,int***,int,int,int);
void ColorBase(unsigned char***,int***,int,int,int);

//>Gradient Textural
void GradTexMultiColor__(int***,float**,int,int,int,int,int,int);

//>Ending
void follow(float**,int,int,float**,float**,int,int,float);
void AddMatrix(float**,float**,float**,int,int,float);
void AddGradImg(int***,float**,float**,int,int,float);
void GaussianFilter2(float**,float**,int,int);
void GaussianFilter2N(float**,int,int,int);
void NonMaxLocSuppression(float**,int***,float**,int,int,float);
void Interpol(int,int,int,int,float**,float);
void RestorLastLine(int***,int***,int,int);
void RemoveLastLineColumn(float**,int,int,int);
void RemoveIsolatedPix(float**,int,int,int);

